package Parser;

use strict;
use warnings;
use vars qw/%DATAFIELDS/;

%DATAFIELDS = ();

sub parse_config_string
{
	my $string = shift;
	my $regex = quotemeta ($string);

	while ($string =~ m/\%(!?\d{3}(?:,\d{3})*)?(?:{([^}]+)})?([aAbBcefhHilmnopPqrstTuUvV]|>s)/g)
	{
		my $condition  = (defined ($1) ? $1 : '');
		my $additional = (defined ($2) ? $2 : '');
		my $type = $3;

		my $pattern = quotemeta (quotemeta ($condition . $additional . $type));
		
		my $regex get_regex ($condition, $additional, $type);

		$regex =~ s/$pattern/$regex/g;
	}

	return ($regex);
}

sub get_regex
{
	my $condition = shift;
	my $additional = shift;
	my $type = shift;

	my $regex;
	my $name;
	my $type = 'key';
	
	# match an IP address
	if ($type eq 'a' or $type eq 'A')
	{
		$name = ($type eq 'a' ? 'remote_ip' : 'local_ip');
		$regex = '[\d\.]{7,15}'; # not correct, but works
	}

	# match numeric only
	elsif ($type eq 'B' or $type eq 'b'
			or $type eq 'p' # port
			or $type eq 'P' # PID
			or $type eq 's' or $type eq '>s' # status code
			or $type eq 'T') # time to serve request
	{
		$name = 'bytes'  if ($type eq 'B' or $type eq 'b');
		$name = 'port'   if ($type eq 'p');
		$name = 'PID'    if ($type eq 'P');
		$name = 'status' if ($type eq 's' or $type eq '>s');
		$name = 'time_to_serve' if ($type eq 'T');
		
		$condition = 1 if ($type eq 'b');
		
		$regex = '\d+';
	}
	
	
